
<!doctype html>
<html lang="es" class="no-js">
  <head>
    
      <meta charset="utf-8">
      <meta name="viewport" content="width=device-width,initial-scale=1">
      
      
      
      <link rel="icon" href="../../assets/images/logo.png">
      <meta name="generator" content="mkdocs-1.3.0, mkdocs-material-8.2.9">
    
    
      
        <title>Lenguajes de Programación - Programación en Java</title>
      
    
    
      <link rel="stylesheet" href="../../assets/stylesheets/main.120efc48.min.css">
      
        
        <link rel="stylesheet" href="../../assets/stylesheets/palette.9647289d.min.css">
        
          
          
          <meta name="theme-color" content="#ef5552">
        
      
    
    
    
      
        
        
        <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
        <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Roboto:300,300i,400,400i,700,700i%7CRoboto+Mono:400,400i,700,700i&display=fallback">
        <style>:root{--md-text-font:"Roboto";--md-code-font:"Roboto Mono"}</style>
      
    
    
    <script>__md_scope=new URL("../..",location),__md_get=(e,_=localStorage,t=__md_scope)=>JSON.parse(_.getItem(t.pathname+"."+e)),__md_set=(e,_,t=localStorage,a=__md_scope)=>{try{t.setItem(a.pathname+"."+e,JSON.stringify(_))}catch(e){}}</script>
    
      

    
    
  </head>
  
  
    
    
    
    
    
    <body dir="ltr" data-md-color-scheme="" data-md-color-primary="red" data-md-color-accent="cyan">
  
    
    
    <input class="md-toggle" data-md-toggle="drawer" type="checkbox" id="__drawer" autocomplete="off">
    <input class="md-toggle" data-md-toggle="search" type="checkbox" id="__search" autocomplete="off">
    <label class="md-overlay" for="__drawer"></label>
    <div data-md-component="skip">
      
        
        <a href="#conceptos-de-programacion" class="md-skip">
          Saltar a contenido
        </a>
      
    </div>
    <div data-md-component="announce">
      
    </div>
    
    
      

<header class="md-header" data-md-component="header">
  <nav class="md-header__inner md-grid" aria-label="Cabecera">
    <a href="../.." title="Programación en Java" class="md-header__button md-logo" aria-label="Programación en Java" data-md-component="logo">
      
  
  <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M22 9V7h-2V5a2 2 0 0 0-2-2H4a2 2 0 0 0-2 2v14a2 2 0 0 0 2 2h14a2 2 0 0 0 2-2v-2h2v-2h-2v-2h2v-2h-2V9h2m-4 10H4V5h14v14M6 13h5v4H6v-4m6-6h4v3h-4V7M6 7h5v5H6V7m6 4h4v6h-4v-6Z"/></svg>

    </a>
    <label class="md-header__button md-icon" for="__drawer">
      <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M3 6h18v2H3V6m0 5h18v2H3v-2m0 5h18v2H3v-2Z"/></svg>
    </label>
    <div class="md-header__title" data-md-component="header-title">
      <div class="md-header__ellipsis">
        <div class="md-header__topic">
          <span class="md-ellipsis">
            Programación en Java
          </span>
        </div>
        <div class="md-header__topic" data-md-component="header-topic">
          <span class="md-ellipsis">
            
              Lenguajes de Programación
            
          </span>
        </div>
      </div>
    </div>
    
    
    
      <label class="md-header__button md-icon" for="__search">
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5Z"/></svg>
      </label>
      <div class="md-search" data-md-component="search" role="dialog">
  <label class="md-search__overlay" for="__search"></label>
  <div class="md-search__inner" role="search">
    <form class="md-search__form" name="search">
      <input type="text" class="md-search__input" name="query" aria-label="Búsqueda" placeholder="Búsqueda" autocapitalize="off" autocorrect="off" autocomplete="off" spellcheck="false" data-md-component="search-query" required>
      <label class="md-search__icon md-icon" for="__search">
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5Z"/></svg>
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M20 11v2H8l5.5 5.5-1.42 1.42L4.16 12l7.92-7.92L13.5 5.5 8 11h12Z"/></svg>
      </label>
      <nav class="md-search__options" aria-label="Search">
        
        <button type="reset" class="md-search__icon md-icon" aria-label="Limpiar" tabindex="-1">
          <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M19 6.41 17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12 19 6.41Z"/></svg>
        </button>
      </nav>
      
    </form>
    <div class="md-search__output">
      <div class="md-search__scrollwrap" data-md-scrollfix>
        <div class="md-search-result" data-md-component="search-result">
          <div class="md-search-result__meta">
            Inicializando búsqueda
          </div>
          <ol class="md-search-result__list"></ol>
        </div>
      </div>
    </div>
  </div>
</div>
    
    
  </nav>
  
</header>
    
    <div class="md-container" data-md-component="container">
      
      
        
          
        
      
      <main class="md-main" data-md-component="main">
        <div class="md-main__inner md-grid">
          
            
              
              <div class="md-sidebar md-sidebar--primary" data-md-component="sidebar" data-md-type="navigation" >
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    


<nav class="md-nav md-nav--primary" aria-label="Navegación" data-md-level="0">
  <label class="md-nav__title" for="__drawer">
    <a href="../.." title="Programación en Java" class="md-nav__button md-logo" aria-label="Programación en Java" data-md-component="logo">
      
  
  <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M22 9V7h-2V5a2 2 0 0 0-2-2H4a2 2 0 0 0-2 2v14a2 2 0 0 0 2 2h14a2 2 0 0 0 2-2v-2h2v-2h-2v-2h2v-2h-2V9h2m-4 10H4V5h14v14M6 13h5v4H6v-4m6-6h4v3h-4V7M6 7h5v5H6V7m6 4h4v6h-4v-6Z"/></svg>

    </a>
    Programación en Java
  </label>
  
  <ul class="md-nav__list" data-md-scrollfix>
    
      
      
      

  
  
  
    <li class="md-nav__item">
      <a href="../.." class="md-nav__link">
        Principal
      </a>
    </li>
  

    
      
      
      

  
  
    
  
  
    
    <li class="md-nav__item md-nav__item--active md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_2" type="checkbox" id="__nav_2" checked>
      
      
      
      
        <label class="md-nav__link" for="__nav_2">
          Conceptos Generales
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Conceptos Generales" data-md-level="1">
        <label class="md-nav__title" for="__nav_2">
          <span class="md-nav__icon md-icon"></span>
          Conceptos Generales
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
    
  
  
    <li class="md-nav__item md-nav__item--active">
      
      <input class="md-nav__toggle md-toggle" data-md-toggle="toc" type="checkbox" id="__toc">
      
      
        
      
      
        <label class="md-nav__link md-nav__link--active" for="__toc">
          Lenguajes de Programación
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <a href="./" class="md-nav__link md-nav__link--active">
        Lenguajes de Programación
      </a>
      
        

<nav class="md-nav md-nav--secondary" aria-label="Tabla de contenidos">
  
  
  
    
  
  
    <label class="md-nav__title" for="__toc">
      <span class="md-nav__icon md-icon"></span>
      Tabla de contenidos
    </label>
    <ul class="md-nav__list" data-md-component="toc" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#programas-y-lenguajes-de-programacion" class="md-nav__link">
    Programas y Lenguajes de Programación
  </a>
  
    <nav class="md-nav" aria-label="Programas y Lenguajes de Programación">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#programa" class="md-nav__link">
    Programa
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#algoritmo" class="md-nav__link">
    Algoritmo
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#lenguaje-de-programacion" class="md-nav__link">
    Lenguaje de programación
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#clasificacion-de-los-lenguajes" class="md-nav__link">
    Clasificación de los lenguajes
  </a>
  
    <nav class="md-nav" aria-label="Clasificación de los lenguajes">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#nivel-de-abstraccion" class="md-nav__link">
    Nivel de abstracción
  </a>
  
    <nav class="md-nav" aria-label="Nivel de abstracción">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#lenguaje-de-bajo-nivel" class="md-nav__link">
    Lenguaje de Bajo nivel
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#lenguaje-de-nivel-medio" class="md-nav__link">
    Lenguaje de nivel medio
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#lenguaje-de-alto-nivel" class="md-nav__link">
    Lenguaje de alto nivel
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
          <li class="md-nav__item">
  <a href="#proposito" class="md-nav__link">
    Propósito
  </a>
  
    <nav class="md-nav" aria-label="Propósito">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#lenguaje-de-proposito-general" class="md-nav__link">
    Lenguaje de propósito general
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#lenguaje-de-proposito-especifico" class="md-nav__link">
    Lenguaje de propósito específico
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#lenguaje-de-programacion-de-sistemas" class="md-nav__link">
    Lenguaje de programación de sistemas
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#lenguaje-script" class="md-nav__link">
    Lenguaje script
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
          <li class="md-nav__item">
  <a href="#evolucion-historica" class="md-nav__link">
    Evolución historica
  </a>
  
    <nav class="md-nav" aria-label="Evolución historica">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#lenguaje-de-primera-generacion" class="md-nav__link">
    Lenguaje de primera generación
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#lenguaje-de-segunda-generacion" class="md-nav__link">
    Lenguaje de segunda generación
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#lenguaje-de-tercera-generacion" class="md-nav__link">
    Lenguaje de tercera generación
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#lenguaje-de-cuarta-generacion" class="md-nav__link">
    Lenguaje de cuarta generación
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#lenguaje-de-quinta-generacion" class="md-nav__link">
    Lenguaje de quinta generación
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
          <li class="md-nav__item">
  <a href="#manera-de-ejecutarse" class="md-nav__link">
    Manera de ejecutarse
  </a>
  
    <nav class="md-nav" aria-label="Manera de ejecutarse">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#lenguaje-compilado" class="md-nav__link">
    Lenguaje compilado
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#lenguaje-interpretado" class="md-nav__link">
    Lenguaje interpretado
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
          <li class="md-nav__item">
  <a href="#manera-de-abordar-la-tarea-a-realizar" class="md-nav__link">
    Manera de abordar la tarea a realizar
  </a>
  
    <nav class="md-nav" aria-label="Manera de abordar la tarea a realizar">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#lenguaje-imperativo" class="md-nav__link">
    Lenguaje imperativo
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#lenguaje-declarativo" class="md-nav__link">
    Lenguaje declarativo
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
          <li class="md-nav__item">
  <a href="#paradigma-de-programacion" class="md-nav__link">
    Paradigma de programación
  </a>
  
    <nav class="md-nav" aria-label="Paradigma de programación">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#lenguaje-de-programacion-procedural" class="md-nav__link">
    Lenguaje de programación procedural
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#lenguaje-de-programacion-orientado-a-objetos" class="md-nav__link">
    Lenguaje de programación orientado a objetos
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#lenguaje-de-programacion-funcional" class="md-nav__link">
    Lenguaje de programación funcional
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#lenguaje-de-programacion-logica" class="md-nav__link">
    Lenguaje de programación lógica
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
    </ul>
  
</nav>
      
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../conceptos/" class="md-nav__link">
        Conceptos de Programación
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../disenoAlgoritmos/" class="md-nav__link">
        Diseño de Algoritmos
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../EstructurasControl/" class="md-nav__link">
        Estructuras de Control
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
  </ul>
</nav>
                  </div>
                </div>
              </div>
            
            
              
              <div class="md-sidebar md-sidebar--secondary" data-md-component="sidebar" data-md-type="toc" >
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    

<nav class="md-nav md-nav--secondary" aria-label="Tabla de contenidos">
  
  
  
    
  
  
    <label class="md-nav__title" for="__toc">
      <span class="md-nav__icon md-icon"></span>
      Tabla de contenidos
    </label>
    <ul class="md-nav__list" data-md-component="toc" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#programas-y-lenguajes-de-programacion" class="md-nav__link">
    Programas y Lenguajes de Programación
  </a>
  
    <nav class="md-nav" aria-label="Programas y Lenguajes de Programación">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#programa" class="md-nav__link">
    Programa
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#algoritmo" class="md-nav__link">
    Algoritmo
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#lenguaje-de-programacion" class="md-nav__link">
    Lenguaje de programación
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#clasificacion-de-los-lenguajes" class="md-nav__link">
    Clasificación de los lenguajes
  </a>
  
    <nav class="md-nav" aria-label="Clasificación de los lenguajes">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#nivel-de-abstraccion" class="md-nav__link">
    Nivel de abstracción
  </a>
  
    <nav class="md-nav" aria-label="Nivel de abstracción">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#lenguaje-de-bajo-nivel" class="md-nav__link">
    Lenguaje de Bajo nivel
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#lenguaje-de-nivel-medio" class="md-nav__link">
    Lenguaje de nivel medio
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#lenguaje-de-alto-nivel" class="md-nav__link">
    Lenguaje de alto nivel
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
          <li class="md-nav__item">
  <a href="#proposito" class="md-nav__link">
    Propósito
  </a>
  
    <nav class="md-nav" aria-label="Propósito">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#lenguaje-de-proposito-general" class="md-nav__link">
    Lenguaje de propósito general
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#lenguaje-de-proposito-especifico" class="md-nav__link">
    Lenguaje de propósito específico
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#lenguaje-de-programacion-de-sistemas" class="md-nav__link">
    Lenguaje de programación de sistemas
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#lenguaje-script" class="md-nav__link">
    Lenguaje script
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
          <li class="md-nav__item">
  <a href="#evolucion-historica" class="md-nav__link">
    Evolución historica
  </a>
  
    <nav class="md-nav" aria-label="Evolución historica">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#lenguaje-de-primera-generacion" class="md-nav__link">
    Lenguaje de primera generación
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#lenguaje-de-segunda-generacion" class="md-nav__link">
    Lenguaje de segunda generación
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#lenguaje-de-tercera-generacion" class="md-nav__link">
    Lenguaje de tercera generación
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#lenguaje-de-cuarta-generacion" class="md-nav__link">
    Lenguaje de cuarta generación
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#lenguaje-de-quinta-generacion" class="md-nav__link">
    Lenguaje de quinta generación
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
          <li class="md-nav__item">
  <a href="#manera-de-ejecutarse" class="md-nav__link">
    Manera de ejecutarse
  </a>
  
    <nav class="md-nav" aria-label="Manera de ejecutarse">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#lenguaje-compilado" class="md-nav__link">
    Lenguaje compilado
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#lenguaje-interpretado" class="md-nav__link">
    Lenguaje interpretado
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
          <li class="md-nav__item">
  <a href="#manera-de-abordar-la-tarea-a-realizar" class="md-nav__link">
    Manera de abordar la tarea a realizar
  </a>
  
    <nav class="md-nav" aria-label="Manera de abordar la tarea a realizar">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#lenguaje-imperativo" class="md-nav__link">
    Lenguaje imperativo
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#lenguaje-declarativo" class="md-nav__link">
    Lenguaje declarativo
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
          <li class="md-nav__item">
  <a href="#paradigma-de-programacion" class="md-nav__link">
    Paradigma de programación
  </a>
  
    <nav class="md-nav" aria-label="Paradigma de programación">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#lenguaje-de-programacion-procedural" class="md-nav__link">
    Lenguaje de programación procedural
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#lenguaje-de-programacion-orientado-a-objetos" class="md-nav__link">
    Lenguaje de programación orientado a objetos
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#lenguaje-de-programacion-funcional" class="md-nav__link">
    Lenguaje de programación funcional
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#lenguaje-de-programacion-logica" class="md-nav__link">
    Lenguaje de programación lógica
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
    </ul>
  
</nav>
                  </div>
                </div>
              </div>
            
          
          <div class="md-content" data-md-component="content">
            <article class="md-content__inner md-typeset">
              
                


<h1 id="conceptos-de-programacion">Conceptos de Programación</h1>
<h2 id="programas-y-lenguajes-de-programacion">Programas y Lenguajes de Programación</h2>
<h3 id="programa">Programa</h3>
<p>Es una colección de instrucciones que, debidamente traducidas, serán ejecutadas por un computador para realizar una tarea. En otras palabras, un programa es la descripción de un algoritmo escrita en cierto lenguaje de programación.</p>
<h3 id="algoritmo">Algoritmo</h3>
<p>De manera sencilla, podemos decir que un algoritmo es un método que se emplea para obtener resultados a partir de los datos disponibles. En el capítulo xx se presenta con mayor detalle este concepto.</p>
<h3 id="lenguaje-de-programacion">Lenguaje de programación</h3>
<p>Es una colección de reglas que especifican la forma en que deben escribirse sentencias o instrucciones para que sea posible traducirlas a otras comprensibles para el procesador en que se ejecutarán.
Los programas o código fuente se escriben mediante un editor en un archivo de texto y quedan almacenados en alguna memoria secundaria, por ejemplo, el archivo HolaMundo.cpp contiene un ejemplo de programa escrito en lenguaje de programación C++, y HolaMundo.java contiene un ejemplo de programa escrito en lenguaje de programación Java.</p>
<h2 id="clasificacion-de-los-lenguajes">Clasificación de los lenguajes</h2>
<h3 id="nivel-de-abstraccion">Nivel de abstracción</h3>
<h4 id="lenguaje-de-bajo-nivel">Lenguaje de Bajo nivel</h4>
<p>Son lenguajes totalmente dependientes de la máquina, es decir que el programa que se realiza con este tipo de lenguaje no se puede migrar o utilizar en otras máquinas. Al estar prácticamente diseñados a medida del hardware, aprovechan al máximo las características del mismo. La programación se realiza teniendo muy en cuenta las características del procesador. Normalmente se utiliza una secuencia de bit, es decir, de ceros y unos.</p>
<p>Ejemplos:   </p>
<ul>
<li>Lenguaje maquina</li>
<li>Lenguaje ensablador</li>
</ul>
<h4 id="lenguaje-de-nivel-medio">Lenguaje de nivel medio</h4>
<p>Permiten un mayor grado de abstracción pero al mismo tiempo mantienen algunas características de los lenguajes de bajo nivel. El lenguaje ensamblador es un derivado del lenguaje de máquina y está formado por abreviaturas de letras y números. Con la aparición de este lenguaje se crearon los programas traductores para poder pasar los programas escritos en lenguaje ensamblador a lenguaje de máquina. Como ventaja con respecto al lenguaje de máquina es que los códigos fuentes eran más cortos y los programas creados ocupaban menos memoria.</p>
<p>Ejemplo:</p>
<ul>
<li>C (Operaciones logicas y de desplazamiento de bits)</li>
</ul>
<h4 id="lenguaje-de-alto-nivel">Lenguaje de alto nivel</h4>
<p>Son lenguajes más parecidos al lenguaje humano. Utilizan conceptos, tipos de datos, etc., de una manera cercana al pensamiento humano ignorando (o abstrayéndose) del funcionamiento de la máquina. Se tratan de lenguajes independientes de la arquitectura del computador. Por lo que, en principio, un programa escrito en un lenguaje de alto nivel, se puede migrar de una máquina a otra sin ningún problema. Estos lenguajes permiten al programador olvidarse por completo del funcionamiento interno de la máquina para la que están diseñando el programa. Tan sólo se necesita un traductor que entienda el código fuente como las características de la máquina</p>
<p>Ejemplos:   </p>
<ul>
<li>Java</li>
<li>Ruby</li>
<li>C/C++</li>
<li>Cobol</li>
<li>etc.</li>
</ul>
<h3 id="proposito">Propósito</h3>
<h4 id="lenguaje-de-proposito-general">Lenguaje de propósito general</h4>
<p>Son lenguajes aptos para todo tipo de tareas.</p>
<p>Ejemplos:</p>
<ul>
<li>C/C++</li>
<li>Java</li>
<li>Python</li>
<li>etc.</li>
</ul>
<h4 id="lenguaje-de-proposito-especifico">Lenguaje de propósito específico</h4>
<p>Hechos para un objetivo muy concreto.
Ejemplos:</p>
<ul>
<li>Csound</li>
<li>Ada</li>
<li>SLAM</li>
<li>GPSS</li>
</ul>
<h4 id="lenguaje-de-programacion-de-sistemas">Lenguaje de programación de sistemas</h4>
<p>Diseñados para crear sistemas operativos o drivers.
Ejemplos:</p>
<ul>
<li>C</li>
<li>Arduino</li>
</ul>
<h4 id="lenguaje-script">Lenguaje script</h4>
<p>Para realizar tareas de control y auxiliares. Antiguamente eran los llamados lenguajes de procesamiento por lotes (batch) o JCL ("Joc Control Lenguages"). Se subdividen en varias clases (de shell, de GUI, de programación web, etc.).
Ejemplos:</p>
<ul>
<li>bash</li>
<li>mIRC</li>
<li>JavaScript</li>
</ul>
<h3 id="evolucion-historica">Evolución historica</h3>
<h4 id="lenguaje-de-primera-generacion">Lenguaje de primera generación</h4>
<p>Son los lenguajes que permitían crear programas mediante el código de máquina.</p>
<h4 id="lenguaje-de-segunda-generacion">Lenguaje de segunda generación</h4>
<p>Son aquellos lenguajes de programación del tipo ensamblador. Este tipo de lenguaje permite algunas instrucciones como de suma, de salto, y para almacenar en memoria.</p>
<h4 id="lenguaje-de-tercera-generacion">Lenguaje de tercera generación</h4>
<p>Estos son la mayoría de los lenguajes modernos, diseñados para facilitar la programación a los humanos.
Ejemplos:</p>
<ul>
<li>C/C++</li>
<li>Java</li>
<li>etc.</li>
</ul>
<h4 id="lenguaje-de-cuarta-generacion">Lenguaje de cuarta generación</h4>
<p>Diseñados con un propósito concreto, es decir, para abordar un tipo concreto de problemas.
Ejemplos:</p>
<ul>
<li>NATURAL,</li>
<li>Mathematica</li>
</ul>
<h4 id="lenguaje-de-quinta-generacion">Lenguaje de quinta generación</h4>
<p>La intención es que el programador establezca el"que problema ha de ser resuelto" y las condiciones a reunir, y la máquina lo resuelve. Son utilizados en inteligencia artificial.
Ejemplos:</p>
<ul>
<li>Prolog</li>
</ul>
<h3 id="manera-de-ejecutarse">Manera de ejecutarse</h3>
<h4 id="lenguaje-compilado">Lenguaje compilado</h4>
<p>Un programa traductor traduce el código del programa (código fuente) en código máquina (código objeto). Otro programa, el enlazador, unirá los archivos de código objeto del programa principal con los de las librerías para producir el programa ejecutable.
Ejemplos:</p>
<ul>
<li>C/C++</li>
<li>Go</li>
<li>Java (parcialmente)</li>
<li>etc.</li>
</ul>
<h4 id="lenguaje-interpretado">Lenguaje interpretado</h4>
<p>Un programa (intérprete), ejecuta las instrucciones del programa de manera directa
Ejemplos:</p>
<ul>
<li>Lisp</li>
<li>Ruby</li>
<li>JavaScript</li>
<li>etc.</li>
</ul>
<h3 id="manera-de-abordar-la-tarea-a-realizar">Manera de abordar la tarea a realizar</h3>
<h4 id="lenguaje-imperativo">Lenguaje imperativo</h4>
<p>Indican cómo hay que hacer la tarea, es decir, expresan los pasos a realizar. En este caso, cada instrucción del programa es como una orden que se le entrega al computador para que las ejecute.</p>
<h4 id="lenguaje-declarativo">Lenguaje declarativo</h4>
<p>Estos lenguajes, indican qué hay que hacer. En este caso, cada instrucción es una acción a ejecutar en el computador. Ejemplos: Lisp, Prolog. Otros ejemplos de lenguajes declarativos, pero que no son lenguajes de programación, son HTML (para describir páginas web) o SQL (para consultar bases de datos).</p>
<h3 id="paradigma-de-programacion">Paradigma de programación</h3>
<h4 id="lenguaje-de-programacion-procedural">Lenguaje de programación procedural</h4>
<p>Este tipo de lenguaje divide el problema en partes más pequeñas, que serán realizadas por subprogramas (subrutinas, funciones, procedimientos), que se llaman unas a otras para ser ejecutadas.</p>
<h4 id="lenguaje-de-programacion-orientado-a-objetos">Lenguaje de programación orientado a objetos</h4>
<p>Crean un sistema de clases y objetos siguiendo el ejemplo del mundo real, en el que unos objetos realizan acciones y se comunican con otros objetos.</p>
<h4 id="lenguaje-de-programacion-funcional">Lenguaje de programación funcional</h4>
<p>La tarea se realiza evaluando funciones, (como en Matemáticas), de manera recursiva.</p>
<h4 id="lenguaje-de-programacion-logica">Lenguaje de programación lógica</h4>
<p>La tarea a realizar se expresa empleando lógica formal matemática. Estos lenguajes expresan qué computar.</p>

              
            </article>
          </div>
        </div>
        
      </main>
      
        <footer class="md-footer">
  
    <nav class="md-footer__inner md-grid" aria-label="Pie">
      
        
        <a href="../.." class="md-footer__link md-footer__link--prev" aria-label="Anterior: Principal" rel="prev">
          <div class="md-footer__button md-icon">
            <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M20 11v2H8l5.5 5.5-1.42 1.42L4.16 12l7.92-7.92L13.5 5.5 8 11h12Z"/></svg>
          </div>
          <div class="md-footer__title">
            <div class="md-ellipsis">
              <span class="md-footer__direction">
                Anterior
              </span>
              Principal
            </div>
          </div>
        </a>
      
      
        
        <a href="../conceptos/" class="md-footer__link md-footer__link--next" aria-label="Siguiente: Conceptos de Programación" rel="next">
          <div class="md-footer__title">
            <div class="md-ellipsis">
              <span class="md-footer__direction">
                Siguiente
              </span>
              Conceptos de Programación
            </div>
          </div>
          <div class="md-footer__button md-icon">
            <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M4 11v2h12l-5.5 5.5 1.42 1.42L19.84 12l-7.92-7.92L10.5 5.5 16 11H4Z"/></svg>
          </div>
        </a>
      
    </nav>
  
  <div class="md-footer-meta md-typeset">
    <div class="md-footer-meta__inner md-grid">
      <div class="md-copyright">
  
    <div class="md-copyright__highlight">
      Copyright &copy; 2022 Francisco Escobar
    </div>
  
  
    Made with
    <a href="https://squidfunk.github.io/mkdocs-material/" target="_blank" rel="noopener">
      Material for MkDocs
    </a>
  
</div>
      
    </div>
  </div>
</footer>
      
    </div>
    <div class="md-dialog" data-md-component="dialog">
      <div class="md-dialog__inner md-typeset"></div>
    </div>
    <script id="__config" type="application/json">{"base": "../..", "features": ["content.tabs.link"], "search": "../../assets/javascripts/workers/search.2a1c317c.min.js", "translations": {"clipboard.copied": "Copiado al portapapeles", "clipboard.copy": "Copiar al portapapeles", "search.config.lang": "es", "search.config.pipeline": "trimmer, stopWordFilter", "search.config.separator": "[\\s\\-]+", "search.placeholder": "B\u00fasqueda", "search.result.more.one": "1 m\u00e1s en esta p\u00e1gina", "search.result.more.other": "# m\u00e1s en esta p\u00e1gina", "search.result.none": "No se encontraron documentos", "search.result.one": "1 documento encontrado", "search.result.other": "# documentos encontrados", "search.result.placeholder": "Teclee para comenzar b\u00fasqueda", "search.result.term.missing": "Falta", "select.version.title": "Seleccionar versi\u00f3n"}}</script>
    
    
      <script src="../../assets/javascripts/bundle.6e54b5cd.min.js"></script>
      
    
  </body>
</html>